/*								TPFH Ralit virtuelle									*
 *										(ESIEA)											*
 ****************************************************************************************/
#include <windows.h>					// En-tte standart aux prog. Windows
#include <gl\gl.h>						// fonctions OpenGL
#include <gl\glaux.h>					// Librairie AUX
#include <math.h>
#define LARGEUR 500
#define HAUTEUR 500

GLint cube = 0;

void drawFloor()
{
		glColor4f(0.5f, 0.5f, 0.5f, 0.75f);
		glBegin(GL_QUADS);
			  glVertex3f(-4.0,  4.0, 0.0);
			  glVertex3f( 4.0,  4.0, 0.0);
			  glVertex3f( 4.0, -4.0, 0.0);
			  glVertex3f(-4.0, -4.0, 0.0);
		glEnd();
}

void SetLight()
{
        GLfloat ambientProperties[] = {0.7f, 0.7f, 0.7f, 1.0f};
        GLfloat diffuseProperties[] = {1.0f, 1.0f, 1.0f, 1.0f};
        GLfloat positionProperties[] = {5.0f, 0.0f, 0.0f, 0.0f};
        glLightfv( GL_LIGHT0, GL_AMBIENT, ambientProperties);
        glLightfv( GL_LIGHT0, GL_DIFFUSE, diffuseProperties);
        glLightfv( GL_LIGHT0, GL_POSITION, positionProperties);
        glEnable(GL_LIGHT0);
        glEnable(GL_LIGHTING);
		glEnable(GL_COLOR_MATERIAL);
}

void CALLBACK Main_part(void)
{
        glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
        drawFloor();
        glPushMatrix();
					//initialisation de la transparence
				glEnable(GL_BLEND);
					//la couleur de l'objet va tre (1-alpha_de_l_objet) * couleur du fond et (le_reste * couleur originale)
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
				glTranslatef(0.0f, -2.0f, 5.0f);
				glRotatef((80.0f), -0.5f, 0.3f, -0.8f);
				glRotatef((10.0f), 0.5f, -0.3f, 0.8f);
				glCallList(cube);
					//on dsactive la transparence
				glDisable(GL_BLEND);
        glPopMatrix();
		auxSwapBuffers();
}

void init()
{
		//C'est la partie la plus importante
		//Les couleurs sont dfinies avec un alpha de 0.25
		//qui va servir dans le calcul de la transparence
		//Rappel : 0 = transparent, 1 = opaque
	GLfloat Rouge[] = {0.8f, 0.0f, 0.0f, 0.25f};
	GLfloat Vert[]  = {0.0f, 0.8f, 0.0f, 0.25f};
	GLfloat Bleu[]  = {0.0f, 0.0f, 0.8f, 0.25f};
	GLfloat Jaune[]  = {0.8f, 0.8f, 0.0f, 0.25f};
	GLfloat Rose[]  = {0.8f, 0.0f, 0.8f, 0.25f};
	GLfloat	Cyan[]  = {0.0f, 0.8f, 0.8f, 0.25f};

		//on se contente de dessiner le cube,
		//en utilisant cependant la fonction 
		//glColor4f() au lieu de glColor3f()
		//car la composante alpha compte cette fois_ci
	cube = glGenLists(1);
	glNewList(cube, GL_COMPILE);
		glBegin(GL_QUADS);
		   glColor4fv(Jaune);
		   glNormal3d(-1.0,0.0,0.0);
		   glVertex3d( -1,  1,  1);
		   glVertex3d( -1,  1, -1);
		   glVertex3d( -1, -1, -1);
		   glVertex3d( -1, -1,  1);
		   glColor4fv(Rose);
		   glNormal3d(0.0,1.0,0.0);
		   glVertex3d( -1, 1,  1);
		   glVertex3d(  1, 1,  1);
		   glVertex3d(  1, 1, -1);
		   glVertex3d( -1, 1, -1);
		   glColor4fv(Bleu);
		   glNormal3d(0.0,-1.0,0.0);
		   glVertex3d( -1, -1,  1);
		   glVertex3d( -1, -1, -1);
		   glVertex3d(  1, -1, -1);
		   glVertex3d(  1, -1,  1);
		   glColor4fv(Cyan);
		   glNormal3d(0.0,0.0,-1.0);
		   glVertex3d(  1,  1, -1);
		   glVertex3d(  1, -1, -1);
		   glVertex3d( -1, -1, -1);
		   glVertex3d( -1,  1, -1);
		   glColor4fv(Vert);
		   glNormal3d(1.0,0.0,0.0);
		   glVertex3d( 1,  1,  1);
		   glVertex3d( 1, -1,  1);
		   glVertex3d( 1, -1, -1);
		   glVertex3d( 1,  1, -1);
		   glColor4fv(Rouge);
		   glNormal3d(0.0,0.0,1.0);
		   glVertex3d(-1,  1, 1);
		   glVertex3d(-1, -1, 1);
		   glVertex3d( 1, -1, 1);
		   glVertex3d( 1,  1, 1);
		glEnd();
	glEndList();
}

void CALLBACK reshape (int width, int height)
{
      glViewport (0, 0, width, height);
      glMatrixMode (GL_PROJECTION);
      glLoadIdentity ();
	  gluPerspective (45.0, ((GLfloat) width) / ((GLfloat) height),1.0,100.0);
      glMatrixMode (GL_MODELVIEW);
      glLoadIdentity ();
      gluLookAt (0.0,-7.0,15.0, 0.0, 0.0, 0.0,0.0,0.0, 1.0);
      glEnable(GL_DEPTH_TEST);
      glEnable(GL_POLYGON_SMOOTH);
      SetLight();
}

int main (int argc, char *argv[])
{
		auxInitDisplayMode(AUX_DOUBLE | AUX_RGBA | AUX_DEPTH | AUX_STENCIL);
		auxInitPosition(100,100,LARGEUR,HAUTEUR); 
		auxInitWindow("Transparence");
		auxReshapeFunc(reshape);
		init();
		auxMainLoop(Main_part);
		return 0;
}
